
#include "Premenne.h"
#include "Zdroje.h"
#include "Funkcie.h"



// Procedura vlakna
DWORD WINAPI ThreadProc(LPVOID lpParam) 
{	DWORD mask, readen = 0;
	while(StavPripojeniaCOM)
	{	if(!WaitCommEvent(ComHandle, &mask, NULL))
			break;
		if(mask == EV_RXCHAR)
		{	ClearCommError(ComHandle, &error, &cs);			
			ReadFile(ComHandle, RXbufer, _PocetByteRX, &readen, &osRead);
			//Ak vsetky bajty este neboli nacitane na port....
			if(GetLastError() == ERROR_IO_PENDING)
			{	//Cyklicky zistuj stav zaplnenia portu vsetkymi bajtmi
				while(!GetOverlappedResult(ComHandle, &osRead, &readen, TRUE))
				{	PurgeComm(ComHandle,PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);
					//Ak boli nacitane vsetky bajty, vyskoc z cyklu
					if((GetLastError() != ERROR_IO_INCOMPLETE) || (readen == _PocetByteRX))
						break;				
					memset(RXbufer, 0, sizeof(RXbufer));
				}
			}
			SendMessage(g_hwndDlg, WM_RXCHAR, 0, 0);	
		}
		PurgeComm(ComHandle,PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);
	}	
	existuje_port = 0;
	porty_pamat = 100;
	//Automaticke odpojenie zariadenie (zatvorenie vstkych handle), ked bolo zariadenie odpojene.
	SendMessage(g_hwndDlg, WM_COMMAND, (WPARAM)ID_BUTTON3, 0);
	  return 0;
}







INT_PTR CALLBACK ProceduraDialogu(HWND hwndDlg, UINT Message, WPARAM wParam, LPARAM lParam)
{   
	HFONT hfEdit, hfButton, hfEdit1;
	LOGFONT logFont;
	DWORD	Led_X = 9, 
			Led_Y = 11, 
			Led_CX = 61,
			Led_CY = 4,
			LedZaoblenie = 3;

	//Nastavenie rect struktury Led indikatora udajmi o rozmeroch
	SetRect(&rect_indikator, Led_X, Led_Y, Led_X+Led_CX, Led_Y+Led_CY);
	//spracovanie sprav adresovanych oknu
    switch(Message)
    {   // inicialiyacne udalosti pri otvoreni okna
		case WM_INITDIALOG:
        {   //Spristupnenie rukovate hlavneho dialogoveho okna na globalnej urovni.
			g_hwndDlg = hwndDlg;
			//Vytvorenie timeru pre spravu WM_TIMER
			SetTimer(hwndDlg, _Casovac1, _Cas_1, NULL); 
			//Pozadie hlavneho dialogoveho okna.
			g_pozadieDlg = CreatePatternBrush(LoadBitmap(g_hInstance, MAKEINTRESOURCE(IDB_POZADIE_DLG)));
			//Pozadie okienka bitmapy
			g_pozadie = CreatePatternBrush(LoadBitmap(g_hInstance, MAKEINTRESOURCE(IDB_POZADIE_BMP))); 
			//Nacitanie obrazku v okne.
			obrazok = LoadBitmap(g_hInstance, MAKEINTRESOURCE(ID_OBRAZOK));
			//vlozenie vlastneho kurzoru do okna
			SetClassLong(hwndDlg, GCL_HCURSOR,(LONG_PTR)LoadCursor(g_hInstance, MAKEINTRESOURCE(IDC_CURSOR)));
			//Vlozenie vlastnej ikony do programu
			SetClassLong(hwndDlg, GCL_HICONSM,(LONG_PTR)LoadIcon(g_hInstance, MAKEINTRESOURCE(IDI_ICON)));  
			//Tien okna
		//	SetClassLong(hwndDlg, GCL_STYLE,(LONG_PTR)CS_DROPSHADOW);   			
			//nacitanie vlastneho kurzoru do systemovej triedy "BUTTON"     
		    SetClassLong(GetDlgItem(hwndDlg, ID_BUTTON1), GCL_HCURSOR,(LONG_PTR)LoadCursor(g_hInstance, MAKEINTRESOURCE(IDI_CURSOR2)));
		    
		    SetClassLong(GetDlgItem(hwndDlg, ID_COMBO1), GCL_HCURSOR,(LONG_PTR)LoadCursor(g_hInstance, MAKEINTRESOURCE(IDI_CURSOR2)));
			//Nacitanie obsahu registrov
			ReadRegistry();
			//Nastavenie polohy a rozmerov hlavneho dialogoveho okna
			SetWindowPos(hwndDlg, /*HWND_TOP*/HWND_TOPMOST, LOWORD(g_dwWindowPos), HIWORD(g_dwWindowPos), _SirkaHlOkna, _VyskaHlOkna, SWP_DRAWFRAME);	
			//Nastavenie fontu Tlacitka "Odpojit"
			GetObject(GetStockObject(DEFAULT_GUI_FONT), sizeof(logFont), &logFont);
			lstrcpy(logFont.lfFaceName, TEXT("MS Sans Serif"));
			logFont.lfHeight = -6;
			logFont.lfWeight = 600;		 
			hfButton = CreateFontIndirect(&logFont);
			SendDlgItemMessage(hwndDlg, ID_BUTTON3, WM_SETFONT, (WPARAM)hfButton, (LPARAM)TRUE);  	
			//***************** VYTVORENIE PAMATOVEJ BITMAPY PRE VYKRESLOVANIE OBSAHU HLAVNEHO OKNA ****************************************
			GetClientRect(hwndDlg, &rect_okna); 
		    HDC hdcScreen = GetDC(hwndDlg); 
		    //vytvorii pamatove HDC kompatibilne s HDC okna
		    g_hdcMemWindow = CreateCompatibleDC(hdcScreen); 
		    ///Vytvori rastrovy obrazok kompatibilny s oknom.
		    HBITMAP hBitmap = CreateCompatibleBitmap(hdcScreen, rect_okna.right, rect_okna.bottom); 
		    SelectObject(g_hdcMemWindow, hBitmap);   
			//Prvotne vyplnenie bitmapy texturou pozadia
		    FillRect(g_hdcMemWindow, &rect_okna, g_pozadie);
		    ReleaseDC(hwndDlg, hdcScreen);
		    DeleteObject(hBitmap);  	
			//**********************************************************************************************************
			//Stanovenie obdlznika kde sa zobrazuju udaje, aby sa pri roznych akciach aktualizoval len ten a neblikali prvky okna
			rect_hl.left = 19;
			rect_hl.right = rect_okna.right - 22;
			rect_hl.top = 102;
			rect_hl.bottom = rect_okna.bottom - 36;// - 126;			
			//**********************************************************************************************************
			//DeleteObject(hfButton);
			//Zobrazenie hlavneho okna, lebo je to modalne dialogove okno.
			ShowWindow(hwndDlg, g_nCmdShow);  
			//Skryje tlacitko ODPOJIT (zatial totiz este nie je otvoreny ziadny COMport)
	        ShowWindow(GetDlgItem(hwndDlg, ID_BUTTON3), SW_HIDE);
				
			SendDlgItemMessage(hwndDlg, ID_COMBO2, CB_ADDSTRING, 0, (LPARAM)" NULL");
			SendDlgItemMessage(hwndDlg, ID_COMBO2, CB_SETCURSEL, 0, 0);	//zvolenie aktualnej polozky
			existuje_port = 0;
			//pamat, aby sa okno neprekreslovalo pri kazdom obnovovani portov, iba ked sa stav existujucich portov zmenil
	        porty_pamat = 100;
	        //Prvotne vyhladanie aktualne pripojenych COM portov a naplnenie ich cislami comboboxu "COM porty".
	        Init_com_portov(hwndDlg);
	        //Naplnenie comboboxu "Rychlost komunikacie" udajmi. 
			SendDlgItemMessage(hwndDlg, ID_COMBO1, CB_ADDSTRING, 0, (LPARAM)" 300");
			SendDlgItemMessage(hwndDlg, ID_COMBO1, CB_ADDSTRING, 0, (LPARAM)" 600");
			SendDlgItemMessage(hwndDlg, ID_COMBO1, CB_ADDSTRING, 0, (LPARAM)" 1200");
			SendDlgItemMessage(hwndDlg, ID_COMBO1, CB_ADDSTRING, 0, (LPARAM)" 1800");
			SendDlgItemMessage(hwndDlg, ID_COMBO1, CB_ADDSTRING, 0, (LPARAM)" 2400");
			SendDlgItemMessage(hwndDlg, ID_COMBO1, CB_ADDSTRING, 0, (LPARAM)" 4800");
			SendDlgItemMessage(hwndDlg, ID_COMBO1, CB_ADDSTRING, 0, (LPARAM)" 7200");
			SendDlgItemMessage(hwndDlg, ID_COMBO1, CB_ADDSTRING, 0, (LPARAM)" 9600");
			SendDlgItemMessage(hwndDlg, ID_COMBO1, CB_ADDSTRING, 0, (LPARAM)" 14400");
			SendDlgItemMessage(hwndDlg, ID_COMBO1, CB_ADDSTRING, 0, (LPARAM)" 19200");
			SendDlgItemMessage(hwndDlg, ID_COMBO1, CB_ADDSTRING, 0, (LPARAM)" 38400");
			SendDlgItemMessage(hwndDlg, ID_COMBO1, CB_ADDSTRING, 0, (LPARAM)" 57600");
			SendDlgItemMessage(hwndDlg, ID_COMBO1, CB_ADDSTRING, 0, (LPARAM)"115200");
			//Zvolenie aktualnej polozky
			SendDlgItemMessage(hwndDlg, ID_COMBO1, CB_SETCURSEL, Aktualna_rychlost, 0);
			//Odoslanie spravy do obsluhy comboboxu rychlosti
			SendMessage(g_hwndDlg, WM_COMMAND, (WPARAM)ID_COMBO1, 0);	
			
			
			
			//Vymzzanie suboru
			FILE *fa;		
			fa = fopen("RegistreSi5351.txt", "w");
			fclose(fa);
	
			
			
				
          return TRUE;
        }   
             
        
        
        //nastavenie pozadia dialogoveho okna a inych jeho prvkov
		//case WM_CTLCOLORLISTBOX:
        //case WM_CTLCOLOREDIT:
        case WM_CTLCOLORSTATIC:
        case WM_CTLCOLORDLG:
        {    SetBkMode((HDC)wParam, TRANSPARENT);
             return (INT_PTR)g_pozadieDlg;
        }    
        
        
		
		
		// Uzivatelsky definovana sprava pre spracovanie prijatych dat z UART
		case WM_RXCHAR:
		{	int f;
			//UINT64 x = 0;		
			if(StavPripojeniaCOM)
			{	//Skopirovanie vsetkych prijatych bajtov z RXbufer[] do pola Cislo[], z ktoreho sa zobrazuje v obsluhe spravy WM_PAINT
				memcpy(Cislo, RXbufer,  sizeof(Cislo));	
				// Prekreslenie bitmapy
				RedrawWindow(hwndDlg, &rect_hl, NULL, RDW_UPDATENOW | RDW_INVALIDATE);		
			}			
			return TRUE;
		}
	


	
	
		
        case WM_COMMAND:
        {	 
			 switch(LOWORD(wParam))
             {  //Tlacitko vymazat
             	case ID_BUTTON4:
             	{ 	//Naplni pole nulami
					memset(Cislo, 0, sizeof(Cislo));
					memset(RXbufer, 0, sizeof(RXbufer));
					memset(TXbufer, 0, sizeof(TXbufer));
				 	// Prekreslenie bitmapy
					RedrawWindow(hwndDlg, &rect_hl, NULL, RDW_UPDATENOW | RDW_INVALIDATE); 	
             		break;
             	}
             
             
             
             	//Tlacitko Poslat
             	case ID_BUTTON2:
             	{	DWORD writen;
					TXbufer[0] = 'A';
					TXbufer[1] = 'B';
					TXbufer[2] = 'C';
					WriteFile(ComHandle, TXbufer, _PocetByteTX, &writen, &osWrite);				 	 	
             		break;
             	}
             
             
             
             
            	//Tlacitko PRIPOJIT RS232
             	case ID_BUTTON1:
             	{   KillTimer(hwndDlg, _Casovac1);
  					// Nacita zvoleny port
             		zvoleny_port = AktivnePorty[(BYTE)SendDlgItemMessage(hwndDlg, ID_COMBO2, CB_GETCURSEL, 0, 0)];
             		//otvori zvoleny port
					if(zvoleny_port)	 
					{	StavPripojeniaCOM = OpenCom(hwndDlg, zvoleny_port);	 
						// VYTVORENIE VLAKNA
						ghThread = CreateThread(NULL, 0, ThreadProc, NULL, 0, 0); 	
					}
             		if(existuje_port)
	             	{	ShowWindow(GetDlgItem(hwndDlg, ID_BUTTON1), SW_HIDE);	//Skryje tlacitko PRIPOJIT
             			ShowWindow(GetDlgItem(hwndDlg, ID_BUTTON3), SW_SHOW);	//Zobrazi tlacitko ODPOJIT
             			EnableWindow(GetDlgItem(hwndDlg, ID_COMBO2), FALSE);	//Deaktivuje volbu portu
             		}
             		else
             			EnableWindow(GetDlgItem(hwndDlg, ID_BUTTON1), FALSE);	//Deaktivuje tlacitko PRIPOJIT
				    // Prekreslenie oblasti okna, kde je "LED indikator" pripojenia	
                    RedrawWindow(hwndDlg, &rect_indikator, NULL, RDW_UPDATENOW | RDW_INVALIDATE);  	
             		break;
             	}   
				 
				 	
             	
                         
             	//Tlacitko ODPOJIT
             	case ID_BUTTON3:
             	{	StavPripojeniaCOM = 0; 					 
					//Zatvorenie portu
					CloseCom();
				//	Wait_ms(100);
             		ShowWindow(GetDlgItem(hwndDlg, ID_BUTTON3), SW_HIDE);	//Skryje tlacitko ODPOJIT
	            	ShowWindow(GetDlgItem(hwndDlg, ID_BUTTON1), SW_SHOW);	//Zobrazi tlacitko PRIPOJIT
	            	EnableWindow(GetDlgItem(hwndDlg, ID_COMBO2), TRUE);		//Aktivuje volbu portu
            		SetTimer(g_hwndDlg, _Casovac1, _Cas_1, NULL); 
					// Prekreslenie oblasti okna, kde je "LED indikator" pripojenia
                    RedrawWindow(hwndDlg, &rect_indikator, NULL, RDW_UPDATENOW | RDW_INVALIDATE);
             		break;
             	}
             	
               	
             	
             	//Volba bitovej rychlosti
             	case ID_COMBO1:
             	{	Aktualna_rychlost = (BYTE)SendDlgItemMessage(hwndDlg, ID_COMBO1, CB_GETCURSEL, 0, 0);
             		if(Aktualna_rychlost == 0)	baudova_rychlost = 300;
             		if(Aktualna_rychlost == 1)	baudova_rychlost = 600;
             		if(Aktualna_rychlost == 2)	baudova_rychlost = 1200;
             		if(Aktualna_rychlost == 3)	baudova_rychlost = 1800;
             		if(Aktualna_rychlost == 4)	baudova_rychlost = 2400;
             		if(Aktualna_rychlost == 5)	baudova_rychlost = 4800;
             		if(Aktualna_rychlost == 6)	baudova_rychlost = 7200;
             		if(Aktualna_rychlost == 7)	baudova_rychlost = 9600;
             		if(Aktualna_rychlost == 8)	baudova_rychlost = 14400;
             		if(Aktualna_rychlost == 9)	baudova_rychlost = 19200;
             		if(Aktualna_rychlost == 10)	baudova_rychlost = 38400;
             		if(Aktualna_rychlost == 11)	baudova_rychlost = 57600;
             		if(Aktualna_rychlost == 12)	baudova_rychlost = 115200;
             		//Zmena rychlosti podla nastavenia
             		dcb.BaudRate = baudova_rychlost;
             		SetCommState(ComHandle, &dcb);
             		//Zapis zvolenej hodnoty do registrov
             		HKEY hKey;
             		if((hKey = registry_OpenKey(REGISTRY_KEY_NAME, NULL)))
						registry_WriteBYTE(hKey, TEXT("Baud/s"), Aktualna_rychlost);
					registry_CloseKey(hKey);
             		//Vynulovanie pracovnych polii
					memset(Cislo, 0, sizeof(Cislo));
					memset(RXbufer, 0, sizeof(RXbufer));
					memset(TXbufer, 0, sizeof(TXbufer));
					PurgeComm(ComHandle, PURGE_RXABORT | PURGE_RXCLEAR);
             		// Prekreslenie bitmapy
					RedrawWindow(hwndDlg, &rect_hl, NULL, RDW_UPDATENOW | RDW_INVALIDATE);
             		break;
             	}
             	
 
 
 
 				//Volba COM portu
             	case ID_COMBO2:
             	{	//Nacitanie zvolenej hodnoty
             		posledny_pripojeny_port = (BYTE)SendDlgItemMessage(hwndDlg, ID_COMBO2, CB_GETCURSEL, 0, 0);
             		//Zapis zvolenej hodnoty do registrov
             		HKEY hKey;
             		if((hKey = registry_OpenKey(REGISTRY_KEY_NAME, NULL)))
						registry_WriteBYTE(hKey, TEXT("Port"), posledny_pripojeny_port);
					registry_CloseKey(hKey);
             		break;
             	}
 
 
              					 			 
				// Zatvorenie dialogoveho okna  
				case IDCANCEL:
				{	DeleteObject(hfButton);
					DeleteObject(hfEdit1);
					CloseCom();
					KillTimer(hwndDlg, _Casovac1);
					WriteRegistry(hwndDlg);
					EndDialog(hwndDlg, LOWORD(wParam));
					PostQuitMessage (0);
					break;
				}
             }
             return TRUE;
        }
        
        
 
		 case WM_TIMER:
        {   switch(wParam)
			{	case _Casovac1: 
				{	
					Hladanie_com_portov(hwndDlg);
					
				//	Beep (800, 400);			  	  	
				}
				break;
			}
			break;
        }  
    
       
       
       
       
       
       
       
       
       
        
        case WM_PAINT: 
        {   PAINTSTRUCT ps;
            HDC hdc;
			SIZE size;
			// Ziskanie handle vykreslovania do okna
            hdc = BeginPaint(hwndDlg, &ps);   		
			// Premazanie obsahu bitmapy vyplnou pozadia           
			FillRect(g_hdcMemWindow, &rect_okna, g_pozadie);   
			// Podfarbenie oblasti, kde sa obnovuju udaje.
			ObdlznikZaobleny(g_hdcMemWindow, 
							rect_hl.left, rect_hl.top, 									// x, y
							rect_hl.right-rect_hl.left, rect_hl.bottom-rect_hl.top, 	// sirka, vyska
							0, 															// zaoblenie
							2, 															// hrubka pera
							RGB(255,255,100), 											// farba pera
							RGB(255,255,170));											// farba stetca					
			//=====================================ZOBRAZENIE CISEL======================================================
			int VelkostPisma = 12,//20,//11,
				X_text = 0,//34,
				Y_text = 90;

			TCHAR text[100];
			LOGFONT logFont;
			//Graficky rezim podporujuci zmenu logFont.lfOrientation pisma
			int GraphicModeOld = SetGraphicsMode (g_hdcMemWindow, GM_ADVANCED);	//GM_COMPATIBLE			
			SetBkMode(g_hdcMemWindow, TRANSPARENT);
			GetObject(GetStockObject(DEFAULT_GUI_FONT), sizeof(logFont), &logFont); 
			COLORREF ColorOld = SetTextColor(g_hdcMemWindow, RGB(0,0,200));					
			lstrcpy(logFont.lfFaceName, "Segoe UI");
			//lstrcpy(logFont.lfFaceName, "Comic Sans MS");
			logFont.lfHeight = -MulDiv (VelkostPisma, GetDeviceCaps (g_hdcMemWindow, LOGPIXELSY), 72);//-70; //Velkost pisma
			//logFont.lfWidth = 13; //Sirka pisma (ak je 0, pouzije sa automaticky najblizsia hodnota)
			logFont.lfWeight = 600;//600; //Tucne pismo
			//logFont.lfEscapement = 0;//-300;//900; //Uhol celeho textu (rotacia)
			//logFont.lfItalic = TRUE;
			//logFont.lfOrientation = 0;//-300;//900; //Zvisly text		
			HFONT hFont = CreateFontIndirect(&logFont);
			HFONT hFontOld = (HFONT)SelectObject(g_hdcMemWindow, hFont); 
																								    				
//			_stprintf(text, "%.2X %.2X %.2X %.2X", Cislo[0], Cislo[1], Cislo[2], Cislo[3]);
//			_stprintf(text, "%d%d%d%d%d%d%d%d%d%d", Cislo[0], Cislo[1], Cislo[2], Cislo[3], Cislo[4], Cislo[5], Cislo[6], Cislo[7], Cislo[8], Cislo[9]);
//			_stprintf(text, "%c%c%c%c%c %c%c%c%c%c %c%c%c", Cislo[0], Cislo[1], Cislo[2], Cislo[3], Cislo[4], Cislo[5], Cislo[6], Cislo[7], Cislo[8], Cislo[9], Cislo[10], Cislo[11], Cislo[12]);
		//	_stprintf(text, "%s", Cislo);
		
			BYTE k = 1, Byte[10];
		 	for(int f = 0; f < 8; f++)
			{	if(k & Cislo[0]) 
					Byte[f] = 1;
				else
					Byte[f] = 0;
				k *= 2;
			}
//			_stprintf(text, "%d%d%d%d%d%d%d%d  A:%d", Byte[7], Byte[6], Byte[5], Byte[4], Byte[3], Byte[2], Byte[1], Byte[0], Cislo[1]);
//			TextOut(g_hdcMemWindow, X_text+25, Y_text+10, text, lstrlen(text));
//			GetTextExtentPoint32(g_hdcMemWindow, text, lstrlen(text), &size);
			
			
			
			
			
			//UINT64 test2;
			unsigned long   pp1, pp2, b2,pp3, freq,  registre, b, a, c; 
			UINT64 fdiv2, a2, rm2, f_xtal, koef, k1, sub1, sub2, subsub1, subsub2, subsubsub, subsubsubsub;
			//double fdiv, rm;
			BYTE	reg_0 = 0,
					reg_1 = 0,
					reg_2 = 0,
					reg_3 = 0,
					reg_4 = 0,
					reg_5 = 0,
					reg_6 = 0,
					reg_7 = 0;
			  
			/*		  
			// Set VCOs of PLLA and PLLB to 900 MHz 
			a = 36;           // Division factor 900/25 MHz 
			b = 0;            // Numerator, sets b/c=0 
			c = 1048575;      //Max. resolution, but irrelevant in this case (b=0) 
			
			//Formula for splitting up the numbers to register data, see AN619 
			pp1 = 128 * a + (unsigned long) (128 * b / c) - 512; 
			pp2 = 128 * b - c * (unsigned long) (128 * b / c); 
			pp3  = c; 
			//*/
						 				 
			//*		
			//	unsigned long freq = 1750000;			 
//			freq = 27333000;	
			freq = 1234567;
			
		//for(freq = 10000000; freq <= 10001000; freq += 1)		 
		{	
			c = 1048575;
			f_xtal = 25000000; 
			koef = 10000000;
			k1 = 900000000;
			
			
			/*
			fdiv2 = (f_xtal * 36 * koef) / freq;
			a2 = (f_xtal * 36) / freq * koef; 
			a = (f_xtal * 36) / freq; 
			rm2 = fdiv2 - a2;
			b2 = (rm2 * c) / koef ;
			//*/
			
			
		//	a = (f_xtal * 36) / freq; 
			//rm2 = ((f_xtal * 36 * koef) / freq) - ((f_xtal * 36) / freq * koef);
			//rm2 = ((koef * f_xtal * 36) / freq) - ( koef * (f_xtal * 36 / freq));
			//rm2 = (koef * (f_xtal * 36) / freq) - ( koef * (f_xtal * 36 / freq));
			//b2 = (rm2 * c) / koef ;
			//b2 = (c * (koef * (f_xtal * 36) / freq) - c * ( koef * (f_xtal * 36 / freq))) / koef ;			
			//b2 = c * (koef * (f_xtal * 36) / freq) / koef - c * (f_xtal * 36 / freq) ;
		//	b2 = (c * (9000000000000000 / freq) / 10000000 - c * (900000000 / freq)) ;			
			//pp1  = 128 * a + (128 * b2 / c) - 512; 
					//pp2 = 128 * b2 - c * (128 * b2 / c); 
	
	
	
	
			
	//		pp1  = 128 * (900000000 / freq) + (128 * (1048575 * (9000000000000000 / freq) / 10000000 - 1048575 * (900000000 / freq)) / 1048575) - 512; 		
	//		pp2 = 128 * (1048575 * (9000000000000000 / freq) / 10000000 - 1048575 * (900000000 / freq)) - 1048575 * (128 * (1048575 * (9000000000000000 / freq) / 10000000 - 1048575 * (900000000 / freq)) / 1048575); 
		
	
	
	
	
	
	
			
			
			
	//		pp1  = 128 * (900000000 / freq) + (128 * (1048575 * (9000000000000000 / freq) / 10000000 - 1048575 * (900000000 / freq)) / 1048575) - 512; 
	
	
	
	
	
	
	
	
	
	//		pp1  = 128 * (k1 / freq) + (128 * (c * (koef * k1 / freq) / koef - c * (k1 / freq)) / c) - 512; 
						
			
	//		pp2 = 128 * (c * (koef * k1 / freq) / koef - c * (k1 / freq)) - c * (128 * (c * (koef * k1 / freq) / koef - c * (k1 / freq)) / c); 
	
	
	
	
	
			/*
			sub1 = k1 / freq;
			sub2 = koef * k1 / freq;
			
			subsub1 = c * sub1;
			subsub2 = c * sub2 / koef;
			
			subsubsub = 128 * (subsub2 - subsub1);	
			subsubsubsub = subsubsub / c;
					
			pp1  = 128 * sub1 + subsubsubsub - 512; 
			pp2 = subsubsub - c * subsubsubsub; 
			//*/
			
			
			
			
			sub1 = 900000000 / freq;
			sub2 = 9000000000000000 / freq;
			
			subsub1 = 1048575 * sub1;
			subsub2 = (1048575 * sub2) / 10000000;
			
			subsubsub = 128 * (subsub2 - subsub1);	
			subsubsubsub = subsubsub / 1048575;
			
			pp1  = 128 * sub1 + subsubsubsub - 512; 
			pp2 = subsubsub - 1048575 * subsubsubsub; 
		
			
	
	
			FILE *fa;					
			fa = fopen("RegistreSi5351.txt", "a+");
			fprintf(fa, "%X\n%X\n%X\n%X\n%X\n%X\n%X\n%X\n\n", (unsigned long)sub1, (unsigned long)sub2, (unsigned long)subsub1, (unsigned long)subsub2, (unsigned long)subsubsub, (unsigned long)subsubsubsub, (unsigned long)pp1, (unsigned long)pp2);			
			fprintf(fa, "%d\n%d\n%d\n%d\n%d\n%d\n%d\n%d\n", (unsigned long)sub1, (unsigned long)sub2, (unsigned long)subsub1, (unsigned long)subsub2, (unsigned long)subsubsub, (unsigned long)subsubsubsub, (unsigned long)pp1, (unsigned long)pp2);			
			fclose(fa);

	
	
	
			
			
			/*
			fdiv = (double) (f_xtal * 36) / freq; //division factor fvco/freq (will be integer part of a+b/c) 
			a = (unsigned long) fdiv; 
			rm = fdiv - a;  //remainder. (equiv. b/c) 
			b = rm * c; 
			pp1  = 128 * a + (unsigned long) (128 * b / c) - 512; 
			pp2 = 128 * b - c * (unsigned long) (128 * b / c); 
			pp3 = c; 
			//*/						 
				
			
			reg_0 = 0xFF;
			reg_1 = 0xFF;
			reg_2 = ((pp1 & 0x00030000) >> 16);
			reg_3 = ((pp1 & 0x0000FF00) >> 8);
			reg_4 = (pp1 & 0x000000FF);
			reg_5 = 0xF0 | ((pp2 & 0x000F0000) >> 16);
			reg_6 = ((pp2 & 0x0000FF00) >> 8);
			reg_7 = (pp2 & 0x000000FF);
			
			
			/*
			registre = reg_3;
			(registre <<= 8) |= reg_2;
			(registre <<= 8) |= reg_1;	
			_stprintf(text, "%.2X", registre);	
			//*/
			
			_stprintf(text, "%.2X %.2X %.2X %.2X %.2X %.2X %.2X %.2X", reg_0, reg_1, reg_2, reg_3, reg_4, reg_5, reg_6, reg_7);	
			TextOut(g_hdcMemWindow, X_text+25, Y_text+10, text, lstrlen(text));

			
			
			/*
			FILE *fa;					
			fa = fopen("RegistreSi5351.txt", "a+");
			//fprintf(fa, "%d      %d  %d\n", freq, pp1, pp2);			
			fprintf(fa, "%d      %d  %d\n", freq, (long int)pp1, (long int)pp2);			
			fclose(fa);
			//*/
			
		}
																	
			SelectObject(g_hdcMemWindow, hFontOld);
		    DeleteObject(hFont);
		    SetTextColor(g_hdcMemWindow, ColorOld);
		    SetGraphicsMode (g_hdcMemWindow, GraphicModeOld);
		    
			//=============================================================================================================
			
			//Vlozenie reprezentacneho obrazku do okna
			DrawState(g_hdcMemWindow, 0, 0,(LPARAM)obrazok, 0, rect_okna.right-102, 10, 0, 0, DST_BITMAP);
					
			/*		   
	   		//premena cisla na bitove 8 miestne pole nul a jednotiek
			BYTE k = 1, Byte[10];
		 	for(int f = 0; f < 8; f++)
			{	if(k & UCFG) 
					Byte[f] = 1;
				else
					Byte[f] = 0;
				k *= 2;
			}
			//*/
		     
			//=============================================================================================================
		   
  			//skopirovanie obsahu bitmapy do okna        
			BitBlt(hdc, 0,/*97*/0, rect_okna.right, rect_okna.bottom/*-29*/, g_hdcMemWindow,0,0,SRCCOPY);  
 
          	//Stavovy led pasik indikacie pripojenia                
            if(StavPripojeniaCOM == 1)
            	LedSvetlo(hdc, RGB(0,255,0), RGB(0,255,255), LedZaoblenie, rect_indikator);	 		
            else
            	LedSvetlo(hdc, RGB(200,200,200), RGB(230,230,230), LedZaoblenie, rect_indikator);
			EndPaint(hwndDlg, &ps);            
             return TRUE;
        }       
       
        
    }
    return FALSE;
}    














// HLAVNY PROGRAM
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow) 
{   g_hInstance = hInstance;
	g_nCmdShow = nCmdShow;
	INITCOMMONCONTROLSEX icc;
    icc.dwSize = sizeof(INITCOMMONCONTROLSEX);
    icc.dwICC = ICC_WIN95_CLASSES;
    if ( !InitCommonControlsEx(&icc) )
       return FALSE;      
 	return DialogBox(hInstance, MAKEINTRESOURCE(IDD_DIALOG), NULL, (DLGPROC)ProceduraDialogu);	
}

